#include "offsets074.h"
#include "ccodes.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>
#include <time.h>

char dbuf[100];
char fbuf[12];

void init074(dshark_074_off* in)
{
	memset(in,0,sizeof(dshark_074_off));
	ReadProcessMemory(DOSBOX_HANDLE,(LPCVOID)0x01D3A1A0,&in->base,4,0);
	in->start=in->base+0x1A20;
}


void reload074(dshark_074_off* in)
{
	memset(&in->path,0,256);
	ReadProcessMemory(DOSBOX_HANDLE,(LPCVOID)in->base+0x18BC,&in->path,256,0);
	memset(&in->name,0,9);
	ReadProcessMemory(DOSBOX_HANDLE,(LPCVOID)in->base+0x1918,&in->name,8,0);
}

void injectVal074(dshark_074_off* in, ccode * code)
{
	WriteProcessMemory(DOSBOX_HANDLE,(LPVOID)in->start+code->offset,&code->value,code->size,0);
}


void memview074(dshark_074_off* in, HWND hwnd, int i, int max)
{
	SendMessage(hwnd,WM_SETREDRAW,0,0);
	
	int gc1 = SendMessage(hwnd,LB_GETCURSEL,0,0);
	
	SendMessage(hwnd,LB_RESETCONTENT,0,0);
	char buf[100];
	char b;
	
	int j;
	while(i<max)
	{
		sprintf(buf,"%.6X ",i);
		
		for(j=0;j<12;++j,++i)
		{
			if(i==max){break;}
			b=0;
			ReadProcessMemory(DOSBOX_HANDLE,(LPCVOID)in->start+i,&b,1,0);
			sprintf(&buf[7+(j*3)],"%.2x ",((int)b)&0xFF);
		}
		
		SendMessage(hwnd,LB_ADDSTRING,0,(LPARAM)buf);
	}
	SendMessage(hwnd,LB_SETCURSEL,gc1,0);
	SendMessage(hwnd,WM_SETREDRAW,1,0);
}

void newscan074(void)
{
	remove("scan.tmp");
}


void fscan074_unknown(dshark_074_off* in, int size, HWND out, HWND callback, int cid, int countid)
{
	scanning=1;
	char * bc = malloc(0xBA0000*4);
	ReadProcessMemory(DOSBOX_HANDLE,(LPCVOID)in->start,bc,0xBA0000,0);
	int i,buffer;
	FILE * fp = fopen("scan.tmp","wb");
	int t = time(0);
	for(i=0;i<0xBA0000;++i)
	{
		buffer=((int*)(&bc[i]))[0] & (0xFFFFFFFF>>((4-size)*8));
		sprintf(dbuf,"%p:%u",i,buffer);
		fprintf(fp,"%s\n",dbuf);
		if(time(0)-t)
		{
			sprintf(fbuf,"%.3u%% done",((i*100)/0xBA0000));
			SetDlgItemText(callback,cid,fbuf);
			t=time(0);
		}
	}
	SetDlgItemText(callback,cid,"100%");
	fclose(fp);
	free(bc);
		sprintf(dbuf,"%u results",i);
	SetDlgItemText(callback,countid,dbuf);
	scanning=0;
}

void fscan074_equal(dshark_074_off* in, int size, int value, HWND out, HWND callback, int cid, int countid)
{
	scanning=1;
	char * bc = malloc(0xBA0000*4);
	ReadProcessMemory(DOSBOX_HANDLE,(LPCVOID)in->start,bc,0xBA0000,0);
	int i,buffer,c=0;
	FILE * fp = fopen("scan.tmp","wb");
	int t = time(0);
	for(i=0;i<0xBA0000;++i)
	{
		buffer=((int*)(&bc[i]))[0] & (0xFFFFFFFF>>((4-size)*8));
		if(buffer==value)
		{
			sprintf(dbuf,"%p:%u",i,value);
			fprintf(fp,"%s\n",dbuf);
			++c;
			if(c<0x1000)
			{
				SendMessage(out,LB_ADDSTRING,0,(LPARAM)dbuf);
			}
		}
		if(time(0)-t)
		{
			sprintf(fbuf,"%.3u%% done",((i*100)/0xBA0000));
			SetDlgItemText(callback,cid,fbuf);
			t=time(0);
		}
	}
	SetDlgItemText(callback,cid,"100%");
	sprintf(dbuf,"%u results",c);
	SetDlgItemText(callback,countid,dbuf);
	fclose(fp);
	free(bc);
	scanning=0;
}


void scan074_equal(dshark_074_off* in, int size, int value, HWND out, HWND callback, int cid, int countid)
{
	FILE * fp = fopen("scan.tmp","rb");
	FILE * fp2 = fopen("scan2.tmp","wb");
	char * bc = malloc(0xBA0000*4);
	ReadProcessMemory(DOSBOX_HANDLE,(LPCVOID)in->start,bc,0xBA0000,0);
	scanning=1;
	int buffer,offset;
	int t = time(0);
	GetDlgItemText(callback,countid,fbuf,99);
	int amt = atoi(fbuf);
	if(amt < 1){return;}
	int i = 0;
	int c = 0;
	while(!feof(fp))
	{
		if(fscanf(fp,"%X:%u\n",&offset,&buffer))
		{
			buffer=((int*)(&bc[offset]))[0] & (0xFFFFFFFF>>((4-size)*8));
			if(value==buffer)
			{
				sprintf(dbuf,"%p:%u",offset,value);
				fprintf(fp2,"%s\n",dbuf);
				if(i<0x1000)
				{
					SendMessage(out,LB_ADDSTRING,0,(LPARAM)dbuf);
				}
				++c;
			}
			++i;
		}
		if(time(0)-t)
		{
			sprintf(fbuf,"%.3u%% done",((i*100)/amt));
			SetDlgItemText(callback,cid,fbuf);
			t=time(0);
		}
	}
	
	
	fclose(fp);
	fclose(fp2);
	free(bc);
	remove("scan.tmp");
	rename("scan2.tmp","scan.tmp");
	SetDlgItemText(callback,cid,"100%");
	sprintf(dbuf,"%u results",c);
	SetDlgItemText(callback,countid,dbuf);
	scanning=0;
}

void scan074_unchanged(dshark_074_off* in, int size, HWND out, HWND callback, int cid, int countid)
{
	FILE * fp = fopen("scan.tmp","rb");
	FILE * fp2 = fopen("scan2.tmp","wb");
	char * bc = malloc(0xBA0000*4);
	ReadProcessMemory(DOSBOX_HANDLE,(LPCVOID)in->start,bc,0xBA0000,0);
	scanning=1;
	int buffer,offset,value;
	int t = time(0);
	GetDlgItemText(callback,countid,fbuf,99);
	int amt = atoi(fbuf);
	if(amt < 1){return;}
	int i = 0;
	int c = 0;
	while(!feof(fp))
	{
		if(fscanf(fp,"%X:%u\n",&offset,&value))
		{
			buffer=((int*)(&bc[offset]))[0] & (0xFFFFFFFF>>((4-size)*8));
			if(value==buffer)
			{
				sprintf(dbuf,"%p:%u",offset,value);
				fprintf(fp2,"%s\n",dbuf);
				if(i<0x1000)
				{
					SendMessage(out,LB_ADDSTRING,0,(LPARAM)dbuf);
				}
				++c;
			}
			++i;
		}
		if(time(0)-t)
		{
			sprintf(fbuf,"%.3u%% done",((i*100)/amt));
			SetDlgItemText(callback,cid,fbuf);
			t=time(0);
		}
	}
	
	
	fclose(fp);
	fclose(fp2);
	free(bc);
	remove("scan.tmp");
	rename("scan2.tmp","scan.tmp");
	SetDlgItemText(callback,cid,"100%");
	sprintf(dbuf,"%u results",c);
	SetDlgItemText(callback,countid,dbuf);
	scanning=0;
}


void scan074_changed(dshark_074_off* in, int size, HWND out, HWND callback, int cid, int countid)
{
	FILE * fp = fopen("scan.tmp","rb");
	FILE * fp2 = fopen("scan2.tmp","wb");
	char * bc = malloc(0xBA0000*4);
	ReadProcessMemory(DOSBOX_HANDLE,(LPCVOID)in->start,bc,0xBA0000,0);
	scanning=1;
	int buffer,offset,value;
	int t = time(0);
	GetDlgItemText(callback,countid,fbuf,99);
	int amt = atoi(fbuf);
	if(amt < 1){return;}
	int i = 0;
	int c = 0;
	while(!feof(fp))
	{
		if(fscanf(fp,"%X:%u\n",&offset,&value))
		{
			buffer=((int*)(&bc[offset]))[0] & (0xFFFFFFFF>>((4-size)*8));
			if(value!=buffer)
			{
				sprintf(dbuf,"%p:%u",offset,buffer);
				fprintf(fp2,"%s\n",dbuf);
				if(i<0x1000)
				{
					SendMessage(out,LB_ADDSTRING,0,(LPARAM)dbuf);
				}
				++c;
			}
			++i;
		}
		if(time(0)-t)
		{
			sprintf(fbuf,"%.3u%% done",((i*100)/amt));
			SetDlgItemText(callback,cid,fbuf);
			t=time(0);
		}
	}
	
	
	fclose(fp);
	fclose(fp2);
	free(bc);
	remove("scan.tmp");
	rename("scan2.tmp","scan.tmp");
	SetDlgItemText(callback,cid,"100%");
	sprintf(dbuf,"%u results",c);
	SetDlgItemText(callback,countid,dbuf);
	scanning=0;
}


void scan074_greaterthan(dshark_074_off* in, int size, int value, HWND out, HWND callback, int cid, int countid)
{
	FILE * fp = fopen("scan.tmp","rb");
	FILE * fp2 = fopen("scan2.tmp","wb");
	char * bc = malloc(0xBA0000*4);
	ReadProcessMemory(DOSBOX_HANDLE,(LPCVOID)in->start,bc,0xBA0000,0);
	scanning=1;
	int buffer,offset;
	int t = time(0);
	GetDlgItemText(callback,countid,fbuf,99);
	int amt = atoi(fbuf);
	if(amt < 1){return;}
	int i = 0;
	int c = 0;
	while(!feof(fp))
	{
		if(fscanf(fp,"%X:%u\n",&offset,&buffer))
		{
			buffer=((int*)(&bc[offset]))[0] & (0xFFFFFFFF>>((4-size)*8));
			if(value<buffer)
			{
				sprintf(dbuf,"%p:%u",offset,buffer);
				fprintf(fp2,"%s\n",dbuf);
				if(i<0x1000)
				{
					SendMessage(out,LB_ADDSTRING,0,(LPARAM)dbuf);
				}
				++c;
			}
			++i;
		}
		if(time(0)-t)
		{
			sprintf(fbuf,"%.3u%% done",((i*100)/amt));
			SetDlgItemText(callback,cid,fbuf);
			t=time(0);
		}
	}
	
	
	fclose(fp);
	fclose(fp2);
	free(bc);
	remove("scan.tmp");
	rename("scan2.tmp","scan.tmp");
	SetDlgItemText(callback,cid,"100%");
	sprintf(dbuf,"%u results",c);
	SetDlgItemText(callback,countid,dbuf);
	scanning=0;
}

void scan074_lessthan(dshark_074_off* in, int size, int value, HWND out, HWND callback, int cid, int countid)
{
	FILE * fp = fopen("scan.tmp","rb");
	FILE * fp2 = fopen("scan2.tmp","wb");
	char * bc = malloc(0xBA0000*4);
	ReadProcessMemory(DOSBOX_HANDLE,(LPCVOID)in->start,bc,0xBA0000,0);
	scanning=1;
	int buffer,offset;
	int t = time(0);
	GetDlgItemText(callback,countid,fbuf,99);
	int amt = atoi(fbuf);
	if(amt < 1){return;}
	int i = 0;
	int c = 0;
	while(!feof(fp))
	{
		if(fscanf(fp,"%X:%u\n",&offset,&buffer))
		{
			buffer=((int*)(&bc[offset]))[0] & (0xFFFFFFFF>>((4-size)*8));
			if(value>buffer)
			{
				sprintf(dbuf,"%p:%u",offset,buffer);
				fprintf(fp2,"%s\n",dbuf);
				if(i<0x1000)
				{
					SendMessage(out,LB_ADDSTRING,0,(LPARAM)dbuf);
				}
				++c;
			}
			++i;
		}
		if(time(0)-t)
		{
			sprintf(fbuf,"%.3u%% done",((i*100)/amt));
			SetDlgItemText(callback,cid,fbuf);
			t=time(0);
		}
	}
	
	
	fclose(fp);
	fclose(fp2);
	free(bc);
	remove("scan.tmp");
	rename("scan2.tmp","scan.tmp");
	SetDlgItemText(callback,cid,"100%");
	sprintf(dbuf,"%u results",c);
	SetDlgItemText(callback,countid,dbuf);
	scanning=0;
}

void scan074_increased(dshark_074_off* in, int size, HWND out, HWND callback, int cid, int countid)
{
	FILE * fp = fopen("scan.tmp","rb");
	FILE * fp2 = fopen("scan2.tmp","wb");
	char * bc = malloc(0xBA0000*4);
	ReadProcessMemory(DOSBOX_HANDLE,(LPCVOID)in->start,bc,0xBA0000,0);
	scanning=1;
	int buffer,offset,value;
	int t = time(0);
	GetDlgItemText(callback,countid,fbuf,99);
	int amt = atoi(fbuf);
	if(amt < 1){return;}
	int i = 0;
	int c = 0;
	while(!feof(fp))
	{
		if(fscanf(fp,"%X:%u\n",&offset,&value))
		{
			buffer=((int*)(&bc[offset]))[0] & (0xFFFFFFFF>>((4-size)*8));
			if(value<buffer)
			{
				sprintf(dbuf,"%p:%u",offset,buffer);
				fprintf(fp2,"%s\n",dbuf);
				if(i<0x1000)
				{
					SendMessage(out,LB_ADDSTRING,0,(LPARAM)dbuf);
				}
				++c;
			}
			++i;
		}
		if(time(0)-t)
		{
			sprintf(fbuf,"%.3u%% done",((i*100)/amt));
			SetDlgItemText(callback,cid,fbuf);
			t=time(0);
		}
	}
	
	
	fclose(fp);
	fclose(fp2);
	free(bc);
	remove("scan.tmp");
	rename("scan2.tmp","scan.tmp");
	SetDlgItemText(callback,cid,"100%");
	sprintf(dbuf,"%u results",c);
	SetDlgItemText(callback,countid,dbuf);
	scanning=0;
}

void scan074_decreased(dshark_074_off* in, int size, HWND out, HWND callback, int cid, int countid)
{
	FILE * fp = fopen("scan.tmp","rb");
	FILE * fp2 = fopen("scan2.tmp","wb");
	char * bc = malloc(0xBA0000*4);
	ReadProcessMemory(DOSBOX_HANDLE,(LPCVOID)in->start,bc,0xBA0000,0);
	scanning=1;
	int buffer,offset,value;
	int t = time(0);
	GetDlgItemText(callback,countid,fbuf,99);
	int amt = atoi(fbuf);
	if(amt < 1){return;}
	int i = 0;
	int c = 0;
	while(!feof(fp))
	{
		if(fscanf(fp,"%X:%u\n",&offset,&value))
		{
			buffer=((int*)(&bc[offset]))[0] & (0xFFFFFFFF>>((4-size)*8));
			if(value>buffer)
			{
				sprintf(dbuf,"%p:%u",offset,buffer);
				fprintf(fp2,"%s\n",dbuf);
				if(i<0x1000)
				{
					SendMessage(out,LB_ADDSTRING,0,(LPARAM)dbuf);
				}
				++c;
			}
			++i;
		}
		if(time(0)-t)
		{
			sprintf(fbuf,"%.3u%% done",((i*100)/amt));
			SetDlgItemText(callback,cid,fbuf);
			t=time(0);
		}
	}
	
	
	fclose(fp);
	fclose(fp2);
	free(bc);
	remove("scan.tmp");
	rename("scan2.tmp","scan.tmp");
	SetDlgItemText(callback,cid,"100%");
	sprintf(dbuf,"%u results",c);
	SetDlgItemText(callback,countid,dbuf);
	scanning=0;
}

